<link rel="import" href="../polymer/polymer.html">
<link rel="import" href="../paper-checkbox/paper-checkbox.html">
<link rel="import" href="../paper-button/paper-button.html">
<link rel="import" href="../iron-form/iron-form.html">
<link rel="import" href="date-input.html">


<dom-module id='simple-form'>
	<template>
		
		<style>
				:host {
					display: inline-block;
				}	
				#basic-form {
					margin: 20px 0;
				}
		</style>
		
		<form is="iron-form" method="post" action="/" id="basic-form">
			<paper-checkbox name="read" required>You must check this box</paper-checkbox><br>
			<br>
			<br>

			<date-input 
				format="DD/MM/YYYY" 
				class="paper-input-input" 
				value="{{fromDate}}" 
				label="from"
				error-message="no valid date"
				max-date="{{maxDate}}"
				min-date="{{minDate}}"
				>
			</date-input>
			<br>
			
			<date-input 
				format="DD/MM/YYYY" 
				class="paper-input-input" 
				value="{{toDate}}" 
				label="to"
				error-message="no valid date"
				max-date="{{maxDate}}"
				min-date="{{minDate}}"
				>
			</date-input>
			
			<br>
			<br>
			<paper-button raised on-click="_submit">Submit</paper-button>

		</form>
		
	</template>

	<script>
		Polymer({
			is: 'simple-form',

			properties: {
				fromDate: {
					type: String
				},
				toDate: {
					type: String
				},
				formElements: {
					type: Object,
					notify: true
				},
				validator: {
					type: Object
				},
				maxDate: {
					type: Date
				},
				minDate: {
					type: Date
				}
			},

			listeners: {
				'iron-form-element-register': '_elementRegistered',
				'iron-form-element-unregister': '_elementUnregistered'
			},

			ready: function() {
				this.formElements = [];
				
				this.validator = new Polymer.IronMeta({type: 'validator'}).byKey('date-validator');
				var minDate = this._setMinDate();
				this.set('toDate', new Date());
				this.set('fromDate', minDate);
				// set optional constraint
				this.set('maxDate', new Date());
				this.set('minDate', minDate);
			},

			_elementRegistered: function(e) {
				this.formElements.push(e.target);
				e.target._parentForm = this;
			},
			
			_elementUnregistered: function(e) {
				var target = e.detail.target;
				if (target) {
					var index = this.formElements.indexOf(target);
					if (index > -1) {
						this.formElements.splice(index, 1);
					}
				}
			},

			_setMinDate: function() {
				var today = new Date();
				return new Date(today.setDate(today.getDate() - 2));
			},

			_submit: function(event) {
				var form = Polymer.dom(event).localTarget.parentElement;
				// didn't find another way to validate without calling the validator
				if(form.validate() && 
					this.validator.validate(this.toDate) && 
					this.validator.validate(this.fromDate)) {
					console.log('form valid');
				} else {
					console.log('form not valid');
				}
			}
		});
	</script>
</dom-module>	